Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1933)
@@ -3297,210 +3332,219 @@
 
 !
-!--    Add IF-condition here: IF not vertical nesting
+!--    In case of vertical nesting no interpolation is needed for the
+!--    horizontal boundaries
+       IF ( nesting_mode /= 'vertical' )  THEN
+       
+!
 !--    Left border pe:
-       IF ( nest_bound_l )  THEN
-          CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_l,   &
-                                    logc_ratio_u_l, nzt_topo_nestbc_l, 'l',    &
-                                    'u' )
-          CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
-                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_l,   &
-                                    logc_ratio_v_l, nzt_topo_nestbc_l, 'l',    &
-                                    'v' )
-          CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_l,   &
-                                    logc_ratio_w_l, nzt_topo_nestbc_l, 'l',    &
-                                    'w' )
-          CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_l,   &
-                                    logc_ratio_u_l, nzt_topo_nestbc_l, 'l',    &
-                                    'e' )
-          IF ( .NOT. neutral )  THEN
-             CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_l, logc_ratio_u_l,               &
-                                       nzt_topo_nestbc_l, 'l', 's' )
-          ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
-                                       logc_u_l, logc_ratio_u_l,               &
-                                       nzt_topo_nestbc_l, 'l', 's' )
-          ENDIF
-
-          IF ( nesting_mode == 'one-way' )  THEN
-             CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
-             CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
-             CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
-             CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
+          IF ( nest_bound_l )  THEN
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,     &
+                                       logc_u_l, logc_ratio_u_l,                &
+                                       nzt_topo_nestbc_l, 'l', 'u' )
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,     &
+                                       logc_v_l, logc_ratio_v_l,                &
+                                       nzt_topo_nestbc_l, 'l', 'v' )
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,     &
+                                       logc_w_l, logc_ratio_w_l,                &
+                                       nzt_topo_nestbc_l, 'l', 'w' )
+             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,     &
+                                       logc_u_l, logc_ratio_u_l,                &
+                                       nzt_topo_nestbc_l, 'l', 'e' )
              IF ( .NOT. neutral )  THEN
-                CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
+                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_l, logc_ratio_u_l,             &
+                                          nzt_topo_nestbc_l, 'l', 's' )
              ENDIF
              IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
+                CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_l, logc_ratio_u_l,             &
+                                          nzt_topo_nestbc_l, 'l', 's' )
              ENDIF
+
+             IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
+                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
+                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
+                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
+                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
+                IF ( .NOT. neutral )  THEN
+                   CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
+                ENDIF
+                IF ( humidity  .OR.  passive_scalar )  THEN
+                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
+                ENDIF
+             ENDIF
+
           ENDIF
 
-       ENDIF
-!
-!--    Right border pe
-       IF ( nest_bound_r )  THEN
-          CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_r,   &
-                                    logc_ratio_u_r, nzt_topo_nestbc_r, 'r',    &
-                                    'u' )
-          CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
-                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_r,   &
-                                    logc_ratio_v_r, nzt_topo_nestbc_r, 'r',    &
-                                    'v' )
-          CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_r,   &
-                                    logc_ratio_w_r, nzt_topo_nestbc_r, 'r',    &
-                                    'w' )
-          CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_r,   &
-                                    logc_ratio_u_r, nzt_topo_nestbc_r, 'r',    &
-                                    'e' )
-          IF ( .NOT. neutral )  THEN
-             CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_r, logc_ratio_u_r,               &
-                                       nzt_topo_nestbc_r, 'r', 's' )
-          ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
-                                       logc_u_r, logc_ratio_u_r,               &
-                                       nzt_topo_nestbc_r, 'r', 's' )
-          ENDIF
-
-          IF ( nesting_mode == 'one-way' )  THEN
-             CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
-             CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
-             CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
-             CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'r', 'e' )
+   !
+   !--    Right border pe
+          IF ( nest_bound_r )  THEN
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,     &
+                                       logc_u_r, logc_ratio_u_r,                &
+                                       nzt_topo_nestbc_r, 'r', 'u' )
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,     &
+                                       logc_v_r, logc_ratio_v_r,                &
+                                       nzt_topo_nestbc_r, 'r', 'v' )
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,     &
+                                       logc_w_r, logc_ratio_w_r,                &
+                                       nzt_topo_nestbc_r, 'r', 'w' )
+             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo,r2yo, r1zo, r2zo, nzb_s_inner,      &
+                                       logc_u_r, logc_ratio_u_r,                &
+                                       nzt_topo_nestbc_r, 'r', 'e' )
              IF ( .NOT. neutral )  THEN
-                CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'r', 's' )
+                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_r, logc_ratio_u_r,             &
+                                          nzt_topo_nestbc_r, 'r', 's' )
              ENDIF
              IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'r', 's' )
+                CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_r, logc_ratio_u_r,             &
+                                          nzt_topo_nestbc_r, 'r', 's' )
              ENDIF
+
+             IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
+                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
+                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
+                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
+                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'r', 'e' )
+                IF ( .NOT. neutral )  THEN
+                   CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'r', 's' )
+                ENDIF
+                IF ( humidity  .OR.  passive_scalar )  THEN
+                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'r', 's' )
+                ENDIF
+             ENDIF
+
           ENDIF
 
-       ENDIF
-!
-!--    South border pe
-       IF ( nest_bound_s )  THEN
-          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_s,   &
-                                    logc_ratio_u_s, nzt_topo_nestbc_s, 's',    &
-                                    'u' )
-          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
-                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_s,   &
-                                    logc_ratio_v_s, nzt_topo_nestbc_s, 's',    &
-                                    'v' )
-          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_s,   &
-                                    logc_ratio_w_s, nzt_topo_nestbc_s, 's',    &
-                                    'w' )
-          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_s,   &
-                                    logc_ratio_u_s, nzt_topo_nestbc_s, 's',    &
-                                    'e' )
-          IF ( .NOT. neutral )  THEN
-             CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_s, logc_ratio_u_s,               &
-                                       nzt_topo_nestbc_s, 's', 's' )
-          ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
-                                       logc_u_s, logc_ratio_u_s,               &
-                                       nzt_topo_nestbc_s, 's', 's' )
-          ENDIF
-
-          IF ( nesting_mode == 'one-way' )  THEN
-             CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
-             CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 's', 'v' )
-             CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 's', 'w' )
-             CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 's', 'e' )
+   !
+   !--    South border pe
+          IF ( nest_bound_s )  THEN
+             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,     &
+                                       logc_u_s, logc_ratio_u_s,                &
+                                       nzt_topo_nestbc_s, 's', 'u' )
+             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,     &
+                                       logc_v_s, logc_ratio_v_s,                &
+                                       nzt_topo_nestbc_s, 's', 'v' )
+             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,     &
+                                       logc_w_s, logc_ratio_w_s,                &
+                                       nzt_topo_nestbc_s, 's','w' )
+             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,     &
+                                       logc_u_s, logc_ratio_u_s,                &
+                                       nzt_topo_nestbc_s, 's', 'e' )
              IF ( .NOT. neutral )  THEN
-                CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 's', 's' )
+                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_s, logc_ratio_u_s,             &
+                                          nzt_topo_nestbc_s, 's', 's' )
              ENDIF
              IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 's', 's' )
+                CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo,r2yo, r1zo, r2zo, nzb_s_inner,   &
+                                          logc_u_s, logc_ratio_u_s,             &
+                                          nzt_topo_nestbc_s, 's', 's' )
              ENDIF
+
+             IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
+                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
+                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 's', 'v' )
+                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 's', 'w' )
+                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 's', 'e' )
+                IF ( .NOT. neutral )  THEN
+                   CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 's', 's' )
+                ENDIF
+                IF ( humidity  .OR.  passive_scalar )  THEN
+                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 's', 's' )
+                ENDIF
+             ENDIF
+
           ENDIF
 
-       ENDIF
-!
-!--    North border pe
-       IF ( nest_bound_n )  THEN
-          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_n,   &
-                                    logc_ratio_u_n, nzt_topo_nestbc_n, 'n',    &
-                                    'u' )
-          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
-                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_n,   &
-                                    logc_ratio_v_n, nzt_topo_nestbc_n, 'n',    &
-                                    'v' )
-          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_n,   &
-                                    logc_ratio_w_n, nzt_topo_nestbc_n, 'n',    &
-                                    'w' )
-          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_n,   &
-                                    logc_ratio_u_n, nzt_topo_nestbc_n, 'n',    &
-                                    'e' )
-          IF ( .NOT. neutral )  THEN
-             CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_n, logc_ratio_u_n,               &
-                                       nzt_topo_nestbc_n, 'n', 's' )
-          ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
-                                       logc_u_n, logc_ratio_u_n,               &
-                                       nzt_topo_nestbc_n, 'n', 's' )
-          ENDIF
-
-          IF ( nesting_mode == 'one-way' )  THEN
-             CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
-             CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 'n', 'v' )
-             CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 'n', 'w' )
-             CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 'n', 'e' )
+   !
+   !--    North border pe
+          IF ( nest_bound_n )  THEN
+             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,     &
+                                       logc_u_n, logc_ratio_u_n,                &
+                                       nzt_topo_nestbc_n, 'n', 'u' )
+             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,     &
+                                       logc_v_n, logc_ratio_v_n,                & 
+                                       nzt_topo_nestbc_n, 'n', 'v' )
+             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,     &
+                                       logc_w_n, logc_ratio_w_n,                &
+                                       nzt_topo_nestbc_n, 'n', 'w' )
+             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,     &
+                                       logc_u_n, logc_ratio_u_n,                &
+                                       nzt_topo_nestbc_n, 'n', 'e' )
              IF ( .NOT. neutral )  THEN
-                CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 'n', 's' )
+                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_n, logc_ratio_u_n,             &
+                                          nzt_topo_nestbc_n, 'n', 's' )
              ENDIF
              IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
+                CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner,  &
+                                          logc_u_n, logc_ratio_u_n,             &
+                                          nzt_topo_nestbc_n, 'n', 's' )
              ENDIF
 
+             IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
+                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
+                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 'n', 'v' )
+                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 'n', 'w' )
+                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 'n', 'e' )
+                IF ( .NOT. neutral )  THEN
+                   CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 'n', 's' )
+                ENDIF
+                IF ( humidity  .OR.  passive_scalar )  THEN
+                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
+                ENDIF
+
+             ENDIF
+
           ENDIF
 
-       ENDIF
+       ENDIF       !: IF ( nesting_mode /= 'vertical' )
 
 !
 !--    All PEs are top-border PEs
-       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
+       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,       &
                                 r2yo, r1zo, r2zo, 'u' )
-       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
+       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,       &
                                 r2yv, r1zo, r2zo, 'v' )
-       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
+       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,       &
                                 r2yo, r1zw, r2zw, 'w' )
-       CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,      &
+       CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,       &
                                 r2yo, r1zo, r2zo, 'e' )
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,   &
+          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,    &
                                    r2yo, r1zo, r2zo, 's' )
        ENDIF
        IF ( humidity .OR. passive_scalar )  THEN
-          CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,     &
+          CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,      &
                                    r2yo, r1zo, r2zo, 's' )
        ENDIF
 
-       IF ( nesting_mode == 'one-way' )  THEN
+       IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
           CALL pmci_extrap_ifoutflow_t( u,  'u' )
           CALL pmci_extrap_ifoutflow_t( v,  'v' )
@@ -3513,5 +3557,5 @@
              CALL pmci_extrap_ifoutflow_t( q, 's' )
           ENDIF
-      ENDIF
+       ENDIF
 
    END SUBROUTINE pmci_interpolation
@@ -3526,16 +3570,16 @@
       IMPLICIT NONE
 
-      CALL pmci_anterp_tophat( u,  uc,  kctu, iflu, ifuu, jflo, jfuo, kflo,    &
+      CALL pmci_anterp_tophat( u,  uc,  kctu, iflu, ifuu, jflo, jfuo, kflo,     &
                                kfuo, ijfc_u, 'u' )
-      CALL pmci_anterp_tophat( v,  vc,  kctu, iflo, ifuo, jflv, jfuv, kflo,    &
+      CALL pmci_anterp_tophat( v,  vc,  kctu, iflo, ifuo, jflv, jfuv, kflo,     &
                                kfuo, ijfc_v, 'v' )
-      CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
+      CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,     &
                                kfuw, ijfc_s, 'w' )
       IF ( .NOT. neutral )  THEN
-         CALL pmci_anterp_tophat( pt, ptc, kctu, iflo, ifuo, jflo, jfuo, kflo, &
+         CALL pmci_anterp_tophat( pt, ptc, kctu, iflo, ifuo, jflo, jfuo, kflo,  &
                                   kfuo, ijfc_s, 's' )
       ENDIF
       IF ( humidity  .OR.  passive_scalar )  THEN
-         CALL pmci_anterp_tophat( q, qc, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
+         CALL pmci_anterp_tophat( q, qc, kctu, iflo, ifuo, jflo, jfuo, kflo,    &
                                   kfuo, ijfc_s, 's' )
       ENDIF
@@ -3545,9 +3589,9 @@
 
 
-   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
-                                   r2z, kb, logc, logc_ratio, nzt_topo_nestbc, &
+   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
+                                   r2z, kb, logc, logc_ratio, nzt_topo_nestbc,  &
                                    edge, var )
 !
-!--   Interpolation of ghost-node values used as the client-domain boundary
+!--   Interpolation of ghost-node values used as the child-domain boundary
 !--   conditions. This subroutine handles the left and right boundaries. It is
 !--   based on trilinear interpolation.
@@ -3555,9 +3599,9 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
                                       INTENT(INOUT) ::  f       !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                           &
                                       INTENT(IN)    ::  fc      !:
-      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),          &
+      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),           &
                                       INTENT(IN)    ::  logc_ratio   !:
       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !:
@@ -3572,10 +3616,10 @@
       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb     !:
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !:
-      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
+      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                 &
                                           INTENT(IN)           ::  logc   !:
       INTEGER(iwp) ::  nzt_topo_nestbc   !:
 
-      CHARACTER(LEN=1),INTENT(IN) ::  edge   !:
-      CHARACTER(LEN=1),INTENT(IN) ::  var    !:
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !:
+      CHARACTER(LEN=1), INTENT(IN) ::  var    !:
 
       INTEGER(iwp) ::  i       !:
@@ -3701,7 +3745,7 @@
                      DO  kcorr = 0, ncorr-1
                         kco = k + kcorr
-                        f(kco,jco,i) = 0.5_wp * ( logc_ratio(1,kcorr,k,j) *    &
-                                                  f(k1,j,i)                    &
-                                                + logc_ratio(2,jcorr,k,j) *    &
+                        f(kco,jco,i) = 0.5_wp * ( logc_ratio(1,kcorr,k,j) *     &
+                                                  f(k1,j,i)                     &
+                                                + logc_ratio(2,jcorr,k,j) *     &
                                                   f(k,j1,i) )
                      ENDDO
@@ -3747,10 +3791,10 @@
 
 
-   SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
-                                   r2z, kb, logc, logc_ratio,                  &
+   SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
+                                   r2z, kb, logc, logc_ratio,                   &
                                    nzt_topo_nestbc, edge, var )
 
 !
-!--   Interpolation of ghost-node values used as the client-domain boundary
+!--   Interpolation of ghost-node values used as the child-domain boundary
 !--   conditions. This subroutine handles the south and north boundaries. 
 !--   This subroutine is based on trilinear interpolation.
@@ -3758,9 +3802,9 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
                                       INTENT(INOUT) ::  f             !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                           &
                                       INTENT(IN)    ::  fc            !:
-      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nxl:nxr),          &
+      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nxl:nxr),           &
                                       INTENT(IN)    ::  logc_ratio    !:
       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x           !:
@@ -3775,5 +3819,5 @@
       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !:
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
-      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                &
+      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                 &
                                           INTENT(IN)           ::  logc  !:
       INTEGER(iwp) ::  nzt_topo_nestbc   !:
@@ -3902,7 +3946,7 @@
                      DO  kcorr = 0, ncorr-1
                         kco = k + kcorr
-                        f(kco,i,ico) = 0.5_wp * ( logc_ratio(1,kcorr,k,i) *    &
+                        f(kco,i,ico) = 0.5_wp * ( logc_ratio(1,kcorr,k,i) *     &
                                                   f(k1,j,i)  &
-                                                + logc_ratio(2,icorr,k,i) *    &
+                                                + logc_ratio(2,icorr,k,i) *     &
                                                   f(k,j,i1) )
                      ENDDO
@@ -3948,9 +3992,9 @@
  
 
-   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
+   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,   &
                                   r2z, var )
 
 !
-!--   Interpolation of ghost-node values used as the client-domain boundary
+!--   Interpolation of ghost-node values used as the child-domain boundary
 !--   conditions. This subroutine handles the top boundary. 
 !--   This subroutine is based on trilinear interpolation.
@@ -3958,7 +4002,7 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
                                       INTENT(INOUT) ::  f     !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                           &
                                       INTENT(IN)    ::  fc    !:
       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x   !:
